## ros-indigo-csm 1.0.2

=== sm/CMakeLists.txt ===
PROJECT (CSM C CXX)


INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/lib)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

cmake_minimum_required(VERSION 2.4)
set(csm_link_flags "-L.")

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR})

FIND_PACKAGE(GSL REQUIRED)
IF(GSL_FOUND)
	MESSAGE(STATUS "Found GSL:")
	MESSAGE(STATUS "   GSL_LIBRARIES = ${GSL_LIBRARIES}")
	MESSAGE(STATUS "   GSL_INCLUDE_DIR = ${GSL_INCLUDE_DIR}")
	MESSAGE(STATUS "   CMAKE_GSL_CXX_FLAGS = ${CMAKE_GSL_CXX_FLAGS}")
	MESSAGE(STATUS "   GSL_LINK_DIRECTORIES = '${GSL_LINK_DIRECTORIES}'")

 	
	set(csm_c_flags "${csm_c_flags} -I${GSL_INCLUDE_DIR}")
	if(GSL_LINK_DIRECTORIES)	
#		set(csm_link_flags "${csm_link_flags}
		set(csm_link_flags "${csm_link_flags} -L${GSL_LINK_DIRECTORIES}")
	endif(GSL_LINK_DIRECTORIES)	

	set(csm_link_flags "${csm_link_flags} ${GSL_LIBRARIES}")
	
ELSE(GSL_FOUND)
	MESSAGE(FATAL_ERROR "GSL not found.")
ENDIF(GSL_FOUND)

FIND_PACKAGE(Cairo)
IF(CAIRO_FOUND)
	MESSAGE(STATUS "Found Cairo at.")
	MESSAGE(STATUS "   PREFIX_CAIRO= ${PREFIX_CAIRO}")
	MESSAGE(STATUS "   CAIRO_CFLAGS = ${CAIRO_CFLAGS}")
	MESSAGE(STATUS "   CAIRO_LIBRARY = ${CAIRO_LIBRARY}")
	MESSAGE(STATUS "   CAIRO_INCLUDE_DIR = ${CAIRO_INCLUDE_DIR}")
	
	set(csm_link_flags "${csm_link_flags} ${CAIRO_LIBRARY}")
	SET(csm_c_flags "${csm_c_flags} ${CAIRO_CFLAGS} -I${CAIRO_INCLUDE_DIR}")
	
ELSE(CAIRO_FOUND)
	MESSAGE(WARNING "* Cairo not found: plotting programs (e.g., 'log2pdf') will not be built.")
	MESSAGE(WARNING "* install Cairo from http://cairographics.org ")
ENDIF(CAIRO_FOUND)





MESSAGE(STATUS "csm_c_flags = ${csm_c_flags}")
MESSAGE(STATUS "csm_link_flags = ${csm_link_flags}")


SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${csm_c_flags}")
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC -ggdb -Wall")


# for realpath
IF("${CMAKE_SYSTEM}" MATCHES "Linux")
	ADD_DEFINITIONS(-DLINUX)
ENDIF("${CMAKE_SYSTEM}" MATCHES "Linux")

########### Options ########## 

SUBDIRS(lib/options)
SUBDIRS(lib/json-c)
SUBDIRS(lib/egsl)
SUBDIRS(lib/gpc)
SUBDIRS(csm)





########### SM applications ########## 

MACRO(new_executable exec)
	ADD_EXECUTABLE(${exec} apps/${exec}.c)
	TARGET_LINK_LIBRARIES(${exec} csm-static ${csm_link_flags})
	INSTALL(TARGETS ${exec} DESTINATION bin)
ENDMACRO(new_executable exec)

# new_executable(sm0)
new_executable(sm1)
new_executable(sm2)
new_executable(sm3)
new_executable(json_extract)
new_executable(json_extract_field)
new_executable(json_decimate)
new_executable(json_split)
new_executable(json_pipe)
new_executable(carmen2json)
new_executable(json2carmen)
new_executable(ld_noise)
new_executable(ld_slip)
new_executable(ld_fisher)
new_executable(ld_smooth)
new_executable(ld_resample)
new_executable(ld_remove_doubles)
new_executable(ld_alternate)
new_executable(ld_recover)

new_executable(ld_purify)
new_executable(ld_select)
new_executable(ld_cluster_curv)
new_executable(ld_linearize)

new_executable(json2matlab)

new_executable(ld_exp_tro1)

# this are some random tests
# new_executable(ld_stats)
# new_executable(ld_correct)

new_executable(test_json_ld)
new_executable(test_json)



IF(CAIRO_FOUND)
	new_executable(sm_animate)
	new_executable(log2pdf)
ENDIF(CAIRO_FOUND)


ADD_EXECUTABLE(test_math_utils_sanity csm/test_math_utils_sanity.c)
TARGET_LINK_LIBRARIES(test_math_utils_sanity csm-static ${GSL_LIBRARIES})

ENABLE_TESTING()
ADD_TEST(test_math_utils_sanity test_math_utils_sanity)


SET(csm_sources 
./csm/clustering.c
./csm/gpm/gpm.c
./csm/icp/icp.c
./csm/icp/icp_corr_dumb.c
./csm/icp/icp_corr_tricks.c
./csm/icp/icp_covariance.c
./csm/icp/icp_loop.c
./csm/icp/icp_outliers.c
./csm/icp/icp_debug.c
./csm/mbicp/mbicp_interface.c      
./csm/mbicp/MbICP.c      
./csm/mbicp/calcul.c     
./csm/mbicp/percolate.c  
./csm/mbicp/sp_matrix.c
./csm/hsm/hsm.c
./csm/hsm/hsm_interface.c
./csm/json_journal.c
./csm/laser_data.c
./csm/laser_data_carmen.c
./csm/laser_data_fisher.c
./csm/laser_data_json.c
./csm/laser_data_load.c
./csm/laser_data_drawing.c
./csm/laser_data_bbox.c
./csm/logging.c
./csm/math_utils.c
./csm/math_utils_gsl.c
./csm/orientation.c
./csm/sm_options.c
./csm/utils.c
./lib/egsl/egsl.c
./lib/egsl/egsl_conversions.c
./lib/egsl/egsl_misc.c
./lib/egsl/egsl_ops.c
./lib/gpc/gpc.c
./lib/gpc/gpc_utils.c
./lib/json-c/arraylist.c
./lib/json-c/debug.c
./lib/json-c/JSON_checker.c
./lib/json-c/json_more_utils.c
./lib/json-c/json_object.c
./lib/json-c/json_tokener.c
./lib/json-c/json_util.c
./lib/json-c/linkhash.c
./lib/json-c/printbuf.c
./lib/options/options.c
./lib/options/options_interface.c
)

IF(CAIRO_FOUND)
SET(csm_sources ${csm_sources} csm/laser_data_cairo.c)
ENDIF(CAIRO_FOUND)

ADD_LIBRARY(csm-static STATIC ${csm_sources})
TARGET_LINK_LIBRARIES(csm-static ${csm_link_flags})
INSTALL(TARGETS csm-static ARCHIVE DESTINATION lib)

ADD_LIBRARY(csm SHARED ${csm_sources})
TARGET_LINK_LIBRARIES(csm ${csm_link_flags})
INSTALL(TARGETS csm ARCHIVE DESTINATION lib LIBRARY DESTINATION lib)


IF(COMPILE_HSM)

INCLUDE_DIRECTORIES(/sw/include)
LINK_DIRECTORIES(/sw/lib)

ADD_EXECUTABLE(hsm_test00 ./csm/hsm/hsm_test00.c ./csm/hsm/hsm.c)
#TARGET_LINK_LIBRARIES(hsm_test00 csm-static ${csm_link_flags} pgm pnm pbm)
	TARGET_LINK_LIBRARIES(hsm_test00 csm-static ${csm_link_flags} netpbm)
INSTALL(PROGRAMS hsm_test00 DESTINATION bin)

ENDIF(COMPILE_HSM)


SUBDIRS(pkg-config)

if(0)
#
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${csm_c_flags} -Wall")

FILE(GLOB_RECURSE csm_headers csm/*.h)
FILE(GLOB_RECURSE lib_headers lib/*.h)

foreach(header ${csm_headers} ${lib_headers})
	GET_FILENAME_COMPONENT(header_base ${header} NAME_WE)
	GET_FILENAME_COMPONENT(header_dir ${header} PATH)

#	MESSAGE("Ciao ${header_base} ${header_dir}")
	
	CONFIGURE_FILE(header_test.c.in ${header_dir}/${header_base}_header_test.cpp @ONLY)	
	ADD_EXECUTABLE(${header_base}_header_test ${header_dir}/${header_base}_header_test.cpp)
	SET_TARGET_PROPERTIES(${header_base}_header_test  PROPERTIES LINKER_LANGUAGE CXX)
	TARGET_LINK_LIBRARIES(${header_base}_header_test  csm-static ${csm_link_flags})

	CONFIGURE_FILE(header_test.c.in ${header_dir}/${header_base}_header_test2.c @ONLY)	
	ADD_EXECUTABLE(${header_base}_header_test2 ${header_dir}/${header_base}_header_test2.c)
	TARGET_LINK_LIBRARIES(${header_base}_header_test2  csm-static ${csm_link_flags})
	
endforeach(header ${csm_headers} ${lib_headers})
endif(0)

=== docs/example-linking-cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4)
project(myproject)

# Require we have pkgconfig installed
find_package(PkgConfig REQUIRED)
# Tell pkgconfig to look for CSM
pkg_check_modules(CSM REQUIRED csm)

IF(${CSM_FOUND})
	MESSAGE("CSM_LIBRARY_DIRS: ${CSM_LIBRARY_DIRS}")
	MESSAGE("CSM_LIBRARIES: ${CSM_LIBRARIES}")
	MESSAGE("CSM_INCLUDE_DIRS: ${CSM_INCLUDE_DIRS}")

	INCLUDE_DIRECTORIES(${CSM_INCLUDE_DIRS}) # important! 
	LINK_DIRECTORIES(${CSM_LIBRARY_DIRS})    # important! 
ELSE(${CSM_FOUND})	
	MESSAGE(FATAL_ERROR "CSM not found. Check that the environment variable PKG_CONFIG_PATH includes the path containing the file 'csm.pc'.")
ENDIF(${CSM_FOUND})		

add_executable(myprogram myprogram.c)

target_link_libraries(myprogram ${CSM_LIBRARIES}) # important!

=== sm/apps/map/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4)

project(map)


find_package(PkgConfig REQUIRED)
pkg_check_modules(CSM REQUIRED csm)

IF(${CSM_FOUND})
	MESSAGE("CSM_LIBRARY_DIRS: ${CSM_LIBRARY_DIRS}")
	MESSAGE("CSM_LIBRARIES: ${CSM_LIBRARIES}")
	MESSAGE("CSM_INCLUDE_DIRS: ${CSM_INCLUDE_DIRS}")

	INCLUDE_DIRECTORIES(${CSM_INCLUDE_DIRS})
	LINK_DIRECTORIES(${CSM_LIBRARY_DIRS})

ELSE(${CSM_FOUND})	
	MESSAGE(FATAL_ERROR "CSM not found. Check that the environment variable PKG_CONFIG_PATH includes the path containing the file 'csm.pc'.")
ENDIF(${CSM_FOUND})		



set(map1_SRCS
	map1.cpp
)


add_executable(map1 ${map1_SRCS})

target_link_libraries(map1 ${CSM_LIBRARIES})

=== sm/csm/hsm/CMakeLists.txt ===
# This builds the code as itself

cmake_minimum_required(VERSION 2.4)

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pedantic -std=c99")
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ggdb")
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")


ADD_EXECUTABLE(hsm_test00 hsm_test00.c hsm.c)

=== sm/lib/json-c/CMakeLists.txt ===
#SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ansi")
#SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
#SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pedantic")

SET(json-c_sources
	arraylist.c
	debug.c
	json_object.c
	json_tokener.c
	json_util.c
	linkhash.c
	printbuf.c
	JSON_checker.c
	json_more_utils.c
)

ADD_LIBRARY(json-c STATIC ${json-c_sources})

#ADD_EXECUTABLE(test1 test1.c)
ADD_EXECUTABLE(test2 test2.c)

#TARGET_LINK_LIBRARIES(test1 json-c)
TARGET_LINK_LIBRARIES(test2 json-c)


FILE(GLOB json_headers "*.h")
INSTALL(FILES ${json_headers} DESTINATION include/json-c)


INCLUDE(CheckIncludeFile)

MACRO(MY_CHECK_INCLUDE_FILE file VAR)
	CHECK_INCLUDE_FILE(${file} ${file}-exists)
	IF(${${file}-exists})
		SET(${VAR} 1)
	ELSE()
		SET(${VAR} 0)
	ENDIF(${${file}-exists})
ENDMACRO(MY_CHECK_INCLUDE_FILE file VAR)

MY_CHECK_INCLUDE_FILE(fcntl.h HAVE_FCNTL_H)
MY_CHECK_INCLUDE_FILE(inttypes.h HAVE_INTTYPES_H)
MY_CHECK_INCLUDE_FILE(limits.h HAVE_LIMITS_H)
MY_CHECK_INCLUDE_FILE(memory.h HAVE_MEMORY_H)
MY_CHECK_INCLUDE_FILE(stdarg.h HAVE_STDARG_H)
MY_CHECK_INCLUDE_FILE(stdint.h HAVE_STDINT_H)
MY_CHECK_INCLUDE_FILE(stdlib.h HAVE_STDLIB_H)
MY_CHECK_INCLUDE_FILE(strings.h HAVE_STRINGS_H)
MY_CHECK_INCLUDE_FILE(string.h HAVE_STRING_H)
MY_CHECK_INCLUDE_FILE(syslog.h HAVE_SYSLOG_H)
MY_CHECK_INCLUDE_FILE(sys/param.h HAVE_SYS_PARAM_H)
MY_CHECK_INCLUDE_FILE(sys/types.h HAVE_SYS_TYPES_H)
MY_CHECK_INCLUDE_FILE(sys/stat.h HAVE_SYS_STAT_H)
MY_CHECK_INCLUDE_FILE(unistd.h HAVE_UNISTD_H)

MACRO(MY_CHECK_FUNCTION_EXISTS function VAR)
	CHECK_FUNCTION_EXISTS(${function} ${function}-exists)
	IF(${${function}-exists})
		# MESSAGE(STATUS "Exists ${function} = ${${function}-exists}")
		SET(${VAR} 1)
	ELSE()
		# MESSAGE(STATUS "NOT Exists ${function} = ${${function}-exists}")
		SET(${VAR} 0)
	ENDIF(${${function}-exists})
ENDMACRO(MY_CHECK_FUNCTION_EXISTS function VAR)

INCLUDE(CheckFunctionExists)

MY_CHECK_FUNCTION_EXISTS(open HAVE_OPEN)
MY_CHECK_FUNCTION_EXISTS(strubded HAVE_STRUB)
MY_CHECK_FUNCTION_EXISTS(malloc HAVE_MALLOC)
MY_CHECK_FUNCTION_EXISTS(realloc HAVE_REALLOC)
MY_CHECK_FUNCTION_EXISTS(strerror HAVE_STRERROR)
MY_CHECK_FUNCTION_EXISTS(strncasecmp HAVE_STRNCASECMP)
MY_CHECK_FUNCTION_EXISTS(strndup HAVE_STRNDUP)
MY_CHECK_FUNCTION_EXISTS(vasprintf HAVE_VASPRINTF)
MY_CHECK_FUNCTION_EXISTS(vprintf HAVE_VPRINTF)
MY_CHECK_FUNCTION_EXISTS(vsnprintf HAVE_VSNPRINTF)
MY_CHECK_FUNCTION_EXISTS(vsyslog HAVE_VSYSLOG)

CONFIGURE_FILE(config.h.cmake ${CMAKE_CURRENT_SOURCE_DIR}/config.h)

=== sm/lib/egsl/docs/Makefile ===

input=egsl.txt
output=egsl.html

htmlsection=./htmlsection -no-spacer
markdown=Markdown.pl

header=header.html_frag
footer=footer.html_frag 
tmp=tmp


all: $(output)

$(output): $(input) $(header) $(footer)
	$(markdown) $(input) | $(htmlsection) > $(tmp)
	cat $(header) $(tmp) $(footer) > $@
	-rm $(tmp)

clean:
	-rm $(output)

=== debian/changelog ===
ros-indigo-csm (1.0.2-2trusty) trusty; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Isaac I.Y. Saito <130s@2000.jukuin.keio.ac.jp>  Sun, 08 Nov 2015 06:23:55 -0000

=== debian/control ===
Source: ros-indigo-csm
Section: misc
Priority: extra
Maintainer: Isaac I.Y. Saito <130s@2000.jukuin.keio.ac.jp>
Build-Depends: debhelper (>= 9.0.0), cmake, libgsl0-dev
Homepage: http://censi.mit.edu/software/csm
Standards-Version: 3.9.2

Package: ros-indigo-csm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgsl0-dev
Description: This is a ROS 3rd-party wrapper (see REP-136 for more detail) of Andrea Censi's CSM package. From the official website: The C(anonical) Scan Matcher (CSM) is a pure C implementation of a very fast variation of ICP using a point-to-line metric optimized for range-finder scan matching. It is robust enough to be used in industrial prototypes of autonomous mobile robotics, for example at Kuka. CSM is used by a variety of people, though it is hard to keep track because of the open source distribution, especially as packaged in ROS. If you use this software for something cool, let me know.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-csm//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
